﻿using System;
using System.Linq;
using System.Text;
using DevExpress.Xpo;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using DevExpress.Data.Filtering;
using DevExpress.Persistent.Base;
using System.Collections.Generic;
using DevExpress.ExpressApp.Model;
using DevExpress.Persistent.BaseImpl;
using DevExpress.Persistent.Validation;

namespace CRM.Module.BusinessObjects
{
    [DefaultClassOptions]
    //[ImageName("BO_Contact")]
    //[DefaultProperty("DisplayMemberNameForLookupEditorsOfThisType")]
    //[DefaultListViewOptions(MasterDetailMode.ListViewOnly, false, NewItemRowPosition.None)]
    //[Persistent("DatabaseTableName")]
    // Specify more UI options using a declarative approach (https://documentation.devexpress.com/#eXpressAppFramework/CustomDocument112701).
    //订单(订单编号, 交易日期, 销售员, 客户, 订单明细)
    public class 订单 : BaseObject
    { // Inherit from a different class to provide a custom primary key, concurrency and deletion behavior, etc. (https://documentation.devexpress.com/eXpressAppFramework/CustomDocument113146.aspx).
        public 订单(Session session)
            : base(session)
        {
        }

        private string _订单编号;
        public string 订单编号
        {
            get { return _订单编号; }
            set { SetPropertyValue("订单编号", ref _订单编号, value); }
        }

        private DateTime _交易日期;
        public DateTime 交易日期
        {
            get { return _交易日期; }
            set { SetPropertyValue("交易日期", ref _交易日期, value); }
        }

        private string _销售员;
        public string 销售员
        {
            get { return _销售员; }
            set { SetPropertyValue("销售员", ref _销售员, value); }
        }

        private 客户 _客户;
        public 客户 客户
        {
            get { return _客户; }
            set { SetPropertyValue("客户", ref _客户, value); }
        }

        [Association,DevExpress.Xpo.Aggregated]
        public XPCollection<订单明细> 明细
        {
            get { return GetCollection<订单明细>("明细"); }
        }
        public override void AfterConstruction()
        {
            base.AfterConstruction();
            // Place your initialization code here (https://documentation.devexpress.com/eXpressAppFramework/CustomDocument112834.aspx).
        }
        //private string _PersistentProperty;
        //[XafDisplayName("My display name"), ToolTip("My hint message")]
        //[ModelDefault("EditMask", "(000)-00"), Index(0), VisibleInListView(false)]
        //[Persistent("DatabaseColumnName"), RuleRequiredField(DefaultContexts.Save)]
        //public string PersistentProperty {
        //    get { return _PersistentProperty; }
        //    set { SetPropertyValue("PersistentProperty", ref _PersistentProperty, value); }
        //}

        //[Action(Caption = "My UI Action", ConfirmationMessage = "Are you sure?", ImageName = "Attention", AutoCommit = true)]
        //public void ActionMethod() {
        //    // Trigger a custom business logic for the current record in the UI (https://documentation.devexpress.com/eXpressAppFramework/CustomDocument112619.aspx).
        //    this.PersistentProperty = "Paid";
        //}
    }


    //订单明细（产品，数量，单价，总价，折扣）

    public class 订单明细 : BaseObject
    {
        public 订单明细(Session s):base(s)
        {
            
        }

        private 订单 _订单;
        [Association]
        public 订单 订单
        {
            get { return _订单; }
            set { SetPropertyValue("订单", ref _订单, value); }
        }


        private 产品 _产品;
        public 产品 产品
        {
            get { return _产品; }
            set { SetPropertyValue("产品", ref _产品, value); }
        }

        private int _数量;
        public int 数量
        {
            get { return _数量; }
            set { SetPropertyValue("数量", ref _数量, value); }
        }

        private decimal _单价;
        public decimal 单价
        {
            get { return _单价; }
            set { SetPropertyValue("单价", ref _单价, value); }
        }

        private decimal _总价;
        public decimal 总价
        {
            get { return _总价; }
            set { SetPropertyValue("总价", ref _总价, value); }
        }

        private decimal _折扣;
        public decimal 折扣
        {
            get { return _折扣; }
            set { SetPropertyValue("折扣", ref _折扣, value); }
        }

    }

    //客户分类(分类名称-必填，折扣率：如9折，则下订单时产品价格自动打9折)
    [DefaultClassOptions]
    public class 客户类型 : BaseObject
    {
        public 客户类型(Session s):base(s)
        {
            
        }

        private string _分类名称;
        [RuleRequiredField]
        public string 分类名称
        {
            get { return _分类名称; }
            set { SetPropertyValue("分类名称", ref _分类名称, value); }
        }

        private decimal _折扣率;
        public decimal 折扣率
        {
            get { return _折扣率; }
            set { SetPropertyValue("折扣率", ref _折扣率, value); }
        }



    }
    //客户(姓名-必填、客户分类、性别-必填、生日，家庭住址-约300个汉以内足够用了)
    [DefaultClassOptions]
    public class 客户 : BaseObject
    {
        public 客户(Session s) : base(s)
        {
        }

        private string _姓名;
        public string 姓名
        {
            get { return _姓名; }
            set { SetPropertyValue("姓名", ref _姓名, value); }
        }

        private 客户类型 _客户类型;
        public 客户类型 客户类型
        {
            get { return _客户类型; }
            set { SetPropertyValue("客户类型", ref _客户类型, value); }
        }


        private bool _性别;
        public bool 性别
        {
            get { return _性别; }
            set { SetPropertyValue("性别", ref _性别, value); }
        }

        private DateTime _生日;
        public DateTime 生日
        {
            get { return _生日; }
            set { SetPropertyValue("生日", ref _生日, value); }
        }

        private string _家庭住址;
        [Size(300)]
        public string 家庭住址
        {
            get { return _家庭住址; }
            set { SetPropertyValue("家庭住址", ref _家庭住址, value); }
        }

    }

    //产品分类（分类名称-必填）
    [DefaultClassOptions]
    public class 产品分类 : BaseObject
    {
        public 产品分类(Session s):base(s)
        {
            
        }

        private string _分类名称;
        public string 分类名称
        {
            get { return _分类名称; }
            set { SetPropertyValue("分类名称", ref _分类名称, value); }
        }

    }
    //产品（产品名称-必填，型号，备注-不限长度，产品分类，是否有效）
    [DefaultClassOptions]
    public class 产品:BaseObject
    {
        public 产品(Session s):base(s)
        {
            
        }

        private string _产品名称;
        public string 产品名称
        {
            get { return _产品名称; }
            set { SetPropertyValue("产品名称", ref _产品名称, value); }
        }

        private string _型号;
        public string 型号
        {
            get { return _型号; }
            set { SetPropertyValue("型号", ref _型号, value); }
        }

        private string _备注;
        public string 备注
        {
            get { return _备注; }
            set { SetPropertyValue("备注", ref _备注, value); }
        }

        private 产品分类 _产品分类;
        public 产品分类 产品分类
        {
            get { return _产品分类; }
            set { SetPropertyValue("产品分类", ref _产品分类, value); }
        }

        private bool _是否有效;
        public bool 是否有效
        {
            get { return _是否有效; }
            set { SetPropertyValue("是否有效", ref _是否有效, value); }
        }



    }
}